# swagger-java-client

Quote Management APIs
- API version: 5.0
  - Build date: 2020-05-18T20:19:31.351Z[GMT]

Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*

  For more information, please visit [https://developer.ingrammicro.com/contact](https://developer.ingrammicro.com/contact)

*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.QuotesApi;

import java.io.File;
import java.util.*;

public class QuotesApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure OAuth2 access token for authorization: application
        OAuth application = (OAuth) defaultClient.getAuthentication("application");
        application.setAccessToken("YOUR ACCESS TOKEN");

        QuotesApi apiInstance = new QuotesApi();
        String quoteNumber = "quoteNumber_example"; // String | Ingram Micro Quote Number
        String customerNumber = "20-222222"; // String | Your Ingram Micro unique customer number
        String isoCountryCode = "US"; // String | 
        String thirdPartySource = "customer"; // String | Unique identifier used to identify the third party source accessing the services
        try {
            QuoteDetails result = apiInstance.getV5QuotesDetails(quoteNumber, customerNumber, isoCountryCode, thirdPartySource);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling QuotesApi#getV5QuotesDetails");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.QuotesApi;

import java.io.File;
import java.util.*;

public class QuotesApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure OAuth2 access token for authorization: application
        OAuth application = (OAuth) defaultClient.getAuthentication("application");
        application.setAccessToken("YOUR ACCESS TOKEN");

        QuotesApi apiInstance = new QuotesApi();
        QuoteListRequest body = new QuoteListRequest(); // QuoteListRequest | 
        try {
            QuoteListResponse result = apiInstance.postV5QuotesSearch(body);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling QuotesApi#postV5QuotesSearch");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*QuotesApi* | [**getV5QuotesDetails**](docs/QuotesApi.md#getV5QuotesDetails) | **GET** /quotes/{quoteNumber} | Get quote details
*QuotesApi* | [**postV5QuotesSearch**](docs/QuotesApi.md#postV5QuotesSearch) | **POST** /quotes/search | Search quotes

## Documentation for Models

 - [QuoteDetails](docs/QuoteDetails.md)
 - [QuoteDetailsQuoteDetailResponse](docs/QuoteDetailsQuoteDetailResponse.md)
 - [QuoteDetailsQuoteDetailResponseResponsePreamble](docs/QuoteDetailsQuoteDetailResponseResponsePreamble.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes.md)
 - [QuoteDetailsRequest](docs/QuoteDetailsRequest.md)
 - [QuoteDetailsRequestQuoteProductsRequest](docs/QuoteDetailsRequestQuoteProductsRequest.md)
 - [QuoteDetailsRequestQuoteProductsRequestRequestpreamble](docs/QuoteDetailsRequestQuoteProductsRequestRequestpreamble.md)
 - [QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest](docs/QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest.md)
 - [QuoteListRequest](docs/QuoteListRequest.md)
 - [QuoteListRequestQuoteSearchRequest](docs/QuoteListRequestQuoteSearchRequest.md)
 - [QuoteListRequestQuoteSearchRequestRequestPreamble](docs/QuoteListRequestQuoteSearchRequestRequestPreamble.md)
 - [QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest](docs/QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.md)
 - [QuoteListResponse](docs/QuoteListResponse.md)
 - [QuoteListResponseQuoteSearchResponse](docs/QuoteListResponseQuoteSearchResponse.md)
 - [QuoteListResponseQuoteSearchResponseQuoteList](docs/QuoteListResponseQuoteSearchResponseQuoteList.md)
 - [QuoteListResponseQuoteSearchResponseResponsePreamble](docs/QuoteListResponseQuoteSearchResponseResponsePreamble.md)
 - [QuoteProductList](docs/QuoteProductList.md)
 - [QuoteProductListPrice](docs/QuoteProductListPrice.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### application

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
  - : 


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author


