# QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**quoteNumber** | **String** | Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes. |  [optional]
**bidNumber** | **String** | Special Pricing Bid Number, also referred to as a Dart Number by some vendors, is a unique identifier associated with vendor specific products and discounts. |  [optional]
**endUserName** | **String** | End User Name is the end customer name that is associated with a quote in Ingram Micro&#x27;s CRM |  [optional]
**fromDate** | [**LocalDate**](LocalDate.md) | Filter to select the beginning date of a desired date range. The default filter is set to the date the user is logged-in to request quotes. Date format: YYYY-MM-DD - An incorrect date input will result in a message \&quot;Date must be entered as YYYY-MM-DD\&quot; |  [optional]
**toDate** | [**LocalDate**](LocalDate.md) | Filter to select the end date of a desired date range. The default number of days to request is the previous 30 days from the date user has logged in. Date format: YYYY-MM-DD - An incorrect date input will result in a message \&quot;Date must be entered as YYYY-MM-DD\&quot; |  [optional]
**pageIndex** | **String** | Page index or page number for the list of quotes being returned. When less than 25 quotes are returned, the page number will be \&quot;1\&quot;. In cases where more than 25 quotes are returned, and the default quotes per page are 25 (see recordPerPage), then the list will continue on subsequent pages. |  [optional]
**recordsPerPage** | **String** | Number of records (quotes) to display per page in the quote list. The default is 25, but may be increased using the filter by up to 100 records per page. If more than 100 records are requested a message will be returned \&quot;The number of records requested exceeds the 100 record limit.\&quot;  |  [optional]
**sorting** | [**SortingEnum**](#SortingEnum) | Sort applies to the selected column (sortingColumnName) and may be specified in Ascending (asc) or Descending (desc) order. The default sort is Descending (desc) - most recent first. |  [optional]
**sortingColumnName** | **String** | Refers to the column selected to apply the sorting criteria. The default column is dateCreated and will sort by the most recently created quote first with the following in descending order. The default filter retrieves quotes created within the last 30 days. Filtering allows user to select a specific column to sort: quoteNumber, createdDate, lastModifiedDate, expiryDate, and endUserName. |  [optional]
**thirdPartySource** | **String** | Unique identifier used to identify the third party source accessing the services. |  [optional]

<a name="SortingEnum"></a>
## Enum: SortingEnum
Name | Value
---- | -----
ASC | &quot;asc&quot;
DESC | &quot;desc&quot;
