# QuotesApi

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getV5QuotesDetails**](QuotesApi.md#getV5QuotesDetails) | **GET** /quotes/{quoteNumber} | Get quote details
[**postV5QuotesSearch**](QuotesApi.md#postV5QuotesSearch) | **POST** /quotes/search | Search quotes

<a name="getV5QuotesDetails"></a>
# **getV5QuotesDetails**
> QuoteDetails getV5QuotesDetails(quoteNumber, customerNumber, isoCountryCode, thirdPartySource)

Get quote details

The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QuotesApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: application
OAuth application = (OAuth) defaultClient.getAuthentication("application");
application.setAccessToken("YOUR ACCESS TOKEN");

QuotesApi apiInstance = new QuotesApi();
String quoteNumber = "quoteNumber_example"; // String | Ingram Micro Quote Number
String customerNumber = "20-222222"; // String | Your Ingram Micro unique customer number
String isoCountryCode = "US"; // String | 
String thirdPartySource = "customer"; // String | Unique identifier used to identify the third party source accessing the services
try {
    QuoteDetails result = apiInstance.getV5QuotesDetails(quoteNumber, customerNumber, isoCountryCode, thirdPartySource);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QuotesApi#getV5QuotesDetails");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **quoteNumber** | **String**| Ingram Micro Quote Number |
 **customerNumber** | **String**| Your Ingram Micro unique customer number | [default to 20-222222]
 **isoCountryCode** | **String**|  | [default to US]
 **thirdPartySource** | **String**| Unique identifier used to identify the third party source accessing the services | [optional] [default to customer]

### Return type

[**QuoteDetails**](QuoteDetails.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="postV5QuotesSearch"></a>
# **postV5QuotesSearch**
> QuoteListResponse postV5QuotesSearch(body)

Search quotes

The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro&#x27;s CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API. 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QuotesApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: application
OAuth application = (OAuth) defaultClient.getAuthentication("application");
application.setAccessToken("YOUR ACCESS TOKEN");

QuotesApi apiInstance = new QuotesApi();
QuoteListRequest body = new QuoteListRequest(); // QuoteListRequest | 
try {
    QuoteListResponse result = apiInstance.postV5QuotesSearch(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QuotesApi#postV5QuotesSearch");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**QuoteListRequest**](QuoteListRequest.md)|  | [optional]

### Return type

[**QuoteListResponse**](QuoteListResponse.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

