/*
 * Quote Management APIs
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.QuoteDetails;
import io.swagger.client.model.QuoteListRequest;
import io.swagger.client.model.QuoteListResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QuotesApi {
    private ApiClient apiClient;

    public QuotesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public QuotesApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getV5QuotesDetails
     * @param quoteNumber Ingram Micro Quote Number (required)
     * @param customerNumber Your Ingram Micro unique customer number (required)
     * @param isoCountryCode  (required)
     * @param thirdPartySource Unique identifier used to identify the third party source accessing the services (optional, default to customer)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getV5QuotesDetailsCall(String quoteNumber, String customerNumber, String isoCountryCode, String thirdPartySource, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/quotes/{quoteNumber}"
            .replaceAll("\\{" + "quoteNumber" + "\\}", apiClient.escapeString(quoteNumber.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (customerNumber != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("customerNumber", customerNumber));
        if (isoCountryCode != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("isoCountryCode", isoCountryCode));
        if (thirdPartySource != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("thirdPartySource", thirdPartySource));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "application" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getV5QuotesDetailsValidateBeforeCall(String quoteNumber, String customerNumber, String isoCountryCode, String thirdPartySource, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'quoteNumber' is set
        if (quoteNumber == null) {
            throw new ApiException("Missing the required parameter 'quoteNumber' when calling getV5QuotesDetails(Async)");
        }
        // verify the required parameter 'customerNumber' is set
        if (customerNumber == null) {
            throw new ApiException("Missing the required parameter 'customerNumber' when calling getV5QuotesDetails(Async)");
        }
        // verify the required parameter 'isoCountryCode' is set
        if (isoCountryCode == null) {
            throw new ApiException("Missing the required parameter 'isoCountryCode' when calling getV5QuotesDetails(Async)");
        }
        
        com.squareup.okhttp.Call call = getV5QuotesDetailsCall(quoteNumber, customerNumber, isoCountryCode, thirdPartySource, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get quote details
     * The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*
     * @param quoteNumber Ingram Micro Quote Number (required)
     * @param customerNumber Your Ingram Micro unique customer number (required)
     * @param isoCountryCode  (required)
     * @param thirdPartySource Unique identifier used to identify the third party source accessing the services (optional, default to customer)
     * @return QuoteDetails
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QuoteDetails getV5QuotesDetails(String quoteNumber, String customerNumber, String isoCountryCode, String thirdPartySource) throws ApiException {
        ApiResponse<QuoteDetails> resp = getV5QuotesDetailsWithHttpInfo(quoteNumber, customerNumber, isoCountryCode, thirdPartySource);
        return resp.getData();
    }

    /**
     * Get quote details
     * The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*
     * @param quoteNumber Ingram Micro Quote Number (required)
     * @param customerNumber Your Ingram Micro unique customer number (required)
     * @param isoCountryCode  (required)
     * @param thirdPartySource Unique identifier used to identify the third party source accessing the services (optional, default to customer)
     * @return ApiResponse&lt;QuoteDetails&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QuoteDetails> getV5QuotesDetailsWithHttpInfo(String quoteNumber, String customerNumber, String isoCountryCode, String thirdPartySource) throws ApiException {
        com.squareup.okhttp.Call call = getV5QuotesDetailsValidateBeforeCall(quoteNumber, customerNumber, isoCountryCode, thirdPartySource, null, null);
        Type localVarReturnType = new TypeToken<QuoteDetails>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get quote details (asynchronously)
     * The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*
     * @param quoteNumber Ingram Micro Quote Number (required)
     * @param customerNumber Your Ingram Micro unique customer number (required)
     * @param isoCountryCode  (required)
     * @param thirdPartySource Unique identifier used to identify the third party source accessing the services (optional, default to customer)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getV5QuotesDetailsAsync(String quoteNumber, String customerNumber, String isoCountryCode, String thirdPartySource, final ApiCallback<QuoteDetails> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getV5QuotesDetailsValidateBeforeCall(quoteNumber, customerNumber, isoCountryCode, thirdPartySource, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QuoteDetails>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for postV5QuotesSearch
     * @param body  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call postV5QuotesSearchCall(QuoteListRequest body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/quotes/search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "application" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postV5QuotesSearchValidateBeforeCall(QuoteListRequest body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = postV5QuotesSearchCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Search quotes
     * The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro&#x27;s CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API. 
     * @param body  (optional)
     * @return QuoteListResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QuoteListResponse postV5QuotesSearch(QuoteListRequest body) throws ApiException {
        ApiResponse<QuoteListResponse> resp = postV5QuotesSearchWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Search quotes
     * The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro&#x27;s CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API. 
     * @param body  (optional)
     * @return ApiResponse&lt;QuoteListResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QuoteListResponse> postV5QuotesSearchWithHttpInfo(QuoteListRequest body) throws ApiException {
        com.squareup.okhttp.Call call = postV5QuotesSearchValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<QuoteListResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Search quotes (asynchronously)
     * The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro&#x27;s CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API. 
     * @param body  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postV5QuotesSearchAsync(QuoteListRequest body, final ApiCallback<QuoteListResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postV5QuotesSearchValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QuoteListResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
