/*
 * Quote Management APIs
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.LocalDate;
/**
 * QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-05-18T20:19:31.351Z[GMT]")
public class QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest {
  @SerializedName("quoteNumber")
  private String quoteNumber = null;

  @SerializedName("bidNumber")
  private String bidNumber = null;

  @SerializedName("endUserName")
  private String endUserName = null;

  @SerializedName("fromDate")
  private LocalDate fromDate = null;

  @SerializedName("toDate")
  private LocalDate toDate = null;

  @SerializedName("pageIndex")
  private String pageIndex = null;

  @SerializedName("recordsPerPage")
  private String recordsPerPage = null;

  /**
   * Sort applies to the selected column (sortingColumnName) and may be specified in Ascending (asc) or Descending (desc) order. The default sort is Descending (desc) - most recent first.
   */
  @JsonAdapter(SortingEnum.Adapter.class)
  public enum SortingEnum {
    ASC("asc"),
    DESC("desc");

    private String value;

    SortingEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static SortingEnum fromValue(String text) {
      for (SortingEnum b : SortingEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<SortingEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SortingEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SortingEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SortingEnum.fromValue(String.valueOf(value));
      }
    }
  }  @SerializedName("sorting")
  private SortingEnum sorting = null;

  @SerializedName("sortingColumnName")
  private String sortingColumnName = null;

  @SerializedName("thirdPartySource")
  private String thirdPartySource = null;

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest quoteNumber(String quoteNumber) {
    this.quoteNumber = quoteNumber;
    return this;
  }

   /**
   * Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.
   * @return quoteNumber
  **/
  @Schema(description = "Unique identifier generated by Ingram Micro's CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.")
  public String getQuoteNumber() {
    return quoteNumber;
  }

  public void setQuoteNumber(String quoteNumber) {
    this.quoteNumber = quoteNumber;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest bidNumber(String bidNumber) {
    this.bidNumber = bidNumber;
    return this;
  }

   /**
   * Special Pricing Bid Number, also referred to as a Dart Number by some vendors, is a unique identifier associated with vendor specific products and discounts.
   * @return bidNumber
  **/
  @Schema(description = "Special Pricing Bid Number, also referred to as a Dart Number by some vendors, is a unique identifier associated with vendor specific products and discounts.")
  public String getBidNumber() {
    return bidNumber;
  }

  public void setBidNumber(String bidNumber) {
    this.bidNumber = bidNumber;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest endUserName(String endUserName) {
    this.endUserName = endUserName;
    return this;
  }

   /**
   * End User Name is the end customer name that is associated with a quote in Ingram Micro&#x27;s CRM
   * @return endUserName
  **/
  @Schema(description = "End User Name is the end customer name that is associated with a quote in Ingram Micro's CRM")
  public String getEndUserName() {
    return endUserName;
  }

  public void setEndUserName(String endUserName) {
    this.endUserName = endUserName;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest fromDate(LocalDate fromDate) {
    this.fromDate = fromDate;
    return this;
  }

   /**
   * Filter to select the beginning date of a desired date range. The default filter is set to the date the user is logged-in to request quotes. Date format: YYYY-MM-DD - An incorrect date input will result in a message \&quot;Date must be entered as YYYY-MM-DD\&quot;
   * @return fromDate
  **/
  @Schema(example = "Thu Aug 01 00:00:00 GMT 2019", description = "Filter to select the beginning date of a desired date range. The default filter is set to the date the user is logged-in to request quotes. Date format: YYYY-MM-DD - An incorrect date input will result in a message \"Date must be entered as YYYY-MM-DD\"")
  public LocalDate getFromDate() {
    return fromDate;
  }

  public void setFromDate(LocalDate fromDate) {
    this.fromDate = fromDate;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest toDate(LocalDate toDate) {
    this.toDate = toDate;
    return this;
  }

   /**
   * Filter to select the end date of a desired date range. The default number of days to request is the previous 30 days from the date user has logged in. Date format: YYYY-MM-DD - An incorrect date input will result in a message \&quot;Date must be entered as YYYY-MM-DD\&quot;
   * @return toDate
  **/
  @Schema(example = "Fri Nov 01 00:00:00 GMT 2019", description = "Filter to select the end date of a desired date range. The default number of days to request is the previous 30 days from the date user has logged in. Date format: YYYY-MM-DD - An incorrect date input will result in a message \"Date must be entered as YYYY-MM-DD\"")
  public LocalDate getToDate() {
    return toDate;
  }

  public void setToDate(LocalDate toDate) {
    this.toDate = toDate;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest pageIndex(String pageIndex) {
    this.pageIndex = pageIndex;
    return this;
  }

   /**
   * Page index or page number for the list of quotes being returned. When less than 25 quotes are returned, the page number will be \&quot;1\&quot;. In cases where more than 25 quotes are returned, and the default quotes per page are 25 (see recordPerPage), then the list will continue on subsequent pages.
   * @return pageIndex
  **/
  @Schema(description = "Page index or page number for the list of quotes being returned. When less than 25 quotes are returned, the page number will be \"1\". In cases where more than 25 quotes are returned, and the default quotes per page are 25 (see recordPerPage), then the list will continue on subsequent pages.")
  public String getPageIndex() {
    return pageIndex;
  }

  public void setPageIndex(String pageIndex) {
    this.pageIndex = pageIndex;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest recordsPerPage(String recordsPerPage) {
    this.recordsPerPage = recordsPerPage;
    return this;
  }

   /**
   * Number of records (quotes) to display per page in the quote list. The default is 25, but may be increased using the filter by up to 100 records per page. If more than 100 records are requested a message will be returned \&quot;The number of records requested exceeds the 100 record limit.\&quot; 
   * @return recordsPerPage
  **/
  @Schema(description = "Number of records (quotes) to display per page in the quote list. The default is 25, but may be increased using the filter by up to 100 records per page. If more than 100 records are requested a message will be returned \"The number of records requested exceeds the 100 record limit.\" ")
  public String getRecordsPerPage() {
    return recordsPerPage;
  }

  public void setRecordsPerPage(String recordsPerPage) {
    this.recordsPerPage = recordsPerPage;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest sorting(SortingEnum sorting) {
    this.sorting = sorting;
    return this;
  }

   /**
   * Sort applies to the selected column (sortingColumnName) and may be specified in Ascending (asc) or Descending (desc) order. The default sort is Descending (desc) - most recent first.
   * @return sorting
  **/
  @Schema(description = "Sort applies to the selected column (sortingColumnName) and may be specified in Ascending (asc) or Descending (desc) order. The default sort is Descending (desc) - most recent first.")
  public SortingEnum getSorting() {
    return sorting;
  }

  public void setSorting(SortingEnum sorting) {
    this.sorting = sorting;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest sortingColumnName(String sortingColumnName) {
    this.sortingColumnName = sortingColumnName;
    return this;
  }

   /**
   * Refers to the column selected to apply the sorting criteria. The default column is dateCreated and will sort by the most recently created quote first with the following in descending order. The default filter retrieves quotes created within the last 30 days. Filtering allows user to select a specific column to sort: quoteNumber, createdDate, lastModifiedDate, expiryDate, and endUserName.
   * @return sortingColumnName
  **/
  @Schema(example = "toDate", description = "Refers to the column selected to apply the sorting criteria. The default column is dateCreated and will sort by the most recently created quote first with the following in descending order. The default filter retrieves quotes created within the last 30 days. Filtering allows user to select a specific column to sort: quoteNumber, createdDate, lastModifiedDate, expiryDate, and endUserName.")
  public String getSortingColumnName() {
    return sortingColumnName;
  }

  public void setSortingColumnName(String sortingColumnName) {
    this.sortingColumnName = sortingColumnName;
  }

  public QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest thirdPartySource(String thirdPartySource) {
    this.thirdPartySource = thirdPartySource;
    return this;
  }

   /**
   * Unique identifier used to identify the third party source accessing the services.
   * @return thirdPartySource
  **/
  @Schema(description = "Unique identifier used to identify the third party source accessing the services.")
  public String getThirdPartySource() {
    return thirdPartySource;
  }

  public void setThirdPartySource(String thirdPartySource) {
    this.thirdPartySource = thirdPartySource;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest quoteListRequestQuoteSearchRequestRetrieveQuoteRequest = (QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest) o;
    return Objects.equals(this.quoteNumber, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.quoteNumber) &&
        Objects.equals(this.bidNumber, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.bidNumber) &&
        Objects.equals(this.endUserName, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.endUserName) &&
        Objects.equals(this.fromDate, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.fromDate) &&
        Objects.equals(this.toDate, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.toDate) &&
        Objects.equals(this.pageIndex, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.pageIndex) &&
        Objects.equals(this.recordsPerPage, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.recordsPerPage) &&
        Objects.equals(this.sorting, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.sorting) &&
        Objects.equals(this.sortingColumnName, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.sortingColumnName) &&
        Objects.equals(this.thirdPartySource, quoteListRequestQuoteSearchRequestRetrieveQuoteRequest.thirdPartySource);
  }

  @Override
  public int hashCode() {
    return Objects.hash(quoteNumber, bidNumber, endUserName, fromDate, toDate, pageIndex, recordsPerPage, sorting, sortingColumnName, thirdPartySource);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest {\n");
    
    sb.append("    quoteNumber: ").append(toIndentedString(quoteNumber)).append("\n");
    sb.append("    bidNumber: ").append(toIndentedString(bidNumber)).append("\n");
    sb.append("    endUserName: ").append(toIndentedString(endUserName)).append("\n");
    sb.append("    fromDate: ").append(toIndentedString(fromDate)).append("\n");
    sb.append("    toDate: ").append(toIndentedString(toDate)).append("\n");
    sb.append("    pageIndex: ").append(toIndentedString(pageIndex)).append("\n");
    sb.append("    recordsPerPage: ").append(toIndentedString(recordsPerPage)).append("\n");
    sb.append("    sorting: ").append(toIndentedString(sorting)).append("\n");
    sb.append("    sortingColumnName: ").append(toIndentedString(sortingColumnName)).append("\n");
    sb.append("    thirdPartySource: ").append(toIndentedString(thirdPartySource)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
