/*
 * Quote Management APIs
 * Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*
 *
 * OpenAPI spec version: 5.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.LocalDate;
/**
 * QuoteListResponseQuoteSearchResponseQuoteList
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-05-18T20:19:31.351Z[GMT]")
public class QuoteListResponseQuoteSearchResponseQuoteList {
  @SerializedName("quoteGuid")
  private String quoteGuid = null;

  @SerializedName("quoteName")
  private String quoteName = null;

  @SerializedName("quoteNumber")
  private String quoteNumber = null;

  @SerializedName("revisionNumber")
  private Integer revisionNumber = null;

  @SerializedName("endUserName")
  private String endUserName = null;

  @SerializedName("bidNumber")
  private String bidNumber = null;

  @SerializedName("totalAmount")
  private String totalAmount = null;

  @SerializedName("quoteStatus")
  private String quoteStatus = null;

  @SerializedName("createdDate")
  private LocalDate createdDate = null;

  @SerializedName("lastModifiedDate")
  private LocalDate lastModifiedDate = null;

  @SerializedName("quoteExpiryDate")
  private LocalDate quoteExpiryDate = null;

  public QuoteListResponseQuoteSearchResponseQuoteList quoteGuid(String quoteGuid) {
    this.quoteGuid = quoteGuid;
    return this;
  }

   /**
   * Quote GUID is the primary quote key in Ingram Micro&#x27;s CRM - needed to retrieve quote details.
   * @return quoteGuid
  **/
  @Schema(description = "Quote GUID is the primary quote key in Ingram Micro's CRM - needed to retrieve quote details.")
  public String getQuoteGuid() {
    return quoteGuid;
  }

  public void setQuoteGuid(String quoteGuid) {
    this.quoteGuid = quoteGuid;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList quoteName(String quoteName) {
    this.quoteName = quoteName;
    return this;
  }

   /**
   * Quote Name given to quote by sales team or system generated. Generally used as a reference to identify the quote.
   * @return quoteName
  **/
  @Schema(description = "Quote Name given to quote by sales team or system generated. Generally used as a reference to identify the quote.")
  public String getQuoteName() {
    return quoteName;
  }

  public void setQuoteName(String quoteName) {
    this.quoteName = quoteName;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList quoteNumber(String quoteNumber) {
    this.quoteNumber = quoteNumber;
    return this;
  }

   /**
   * Unique identifier generated by Ingram Micro&#x27;s CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.
   * @return quoteNumber
  **/
  @Schema(description = "Unique identifier generated by Ingram Micro's CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.")
  public String getQuoteNumber() {
    return quoteNumber;
  }

  public void setQuoteNumber(String quoteNumber) {
    this.quoteNumber = quoteNumber;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList revisionNumber(Integer revisionNumber) {
    this.revisionNumber = revisionNumber;
    return this;
  }

   /**
   * When a quote has been revised and updated, the quote number remains the same throughout the lifecycle of the quote, however, a Revision number is updated for each revision of the quote. The revision numbers is associated with the Unique Quote Number.
   * @return revisionNumber
  **/
  @Schema(description = "When a quote has been revised and updated, the quote number remains the same throughout the lifecycle of the quote, however, a Revision number is updated for each revision of the quote. The revision numbers is associated with the Unique Quote Number.")
  public Integer getRevisionNumber() {
    return revisionNumber;
  }

  public void setRevisionNumber(Integer revisionNumber) {
    this.revisionNumber = revisionNumber;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList endUserName(String endUserName) {
    this.endUserName = endUserName;
    return this;
  }

   /**
   * End User Name is the end customer name that is associated with a quote in Ingram Micro&#x27;s CRM
   * @return endUserName
  **/
  @Schema(description = "End User Name is the end customer name that is associated with a quote in Ingram Micro's CRM")
  public String getEndUserName() {
    return endUserName;
  }

  public void setEndUserName(String endUserName) {
    this.endUserName = endUserName;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList bidNumber(String bidNumber) {
    this.bidNumber = bidNumber;
    return this;
  }

   /**
   * Special Pricing Bid Number, also refers to as Dart Number relates to a unique pricing deal associated with a vendor for the quote.
   * @return bidNumber
  **/
  @Schema(description = "Special Pricing Bid Number, also refers to as Dart Number relates to a unique pricing deal associated with a vendor for the quote.")
  public String getBidNumber() {
    return bidNumber;
  }

  public void setBidNumber(String bidNumber) {
    this.bidNumber = bidNumber;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList totalAmount(String totalAmount) {
    this.totalAmount = totalAmount;
    return this;
  }

   /**
   * Total amount of quoted price for all products in the quote.
   * @return totalAmount
  **/
  @Schema(description = "Total amount of quoted price for all products in the quote.")
  public String getTotalAmount() {
    return totalAmount;
  }

  public void setTotalAmount(String totalAmount) {
    this.totalAmount = totalAmount;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList quoteStatus(String quoteStatus) {
    this.quoteStatus = quoteStatus;
    return this;
  }

   /**
   * This refers to the primary status of the quote. API responses will return: Active
   * @return quoteStatus
  **/
  @Schema(description = "This refers to the primary status of the quote. API responses will return: Active")
  public String getQuoteStatus() {
    return quoteStatus;
  }

  public void setQuoteStatus(String quoteStatus) {
    this.quoteStatus = quoteStatus;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList createdDate(LocalDate createdDate) {
    this.createdDate = createdDate;
    return this;
  }

   /**
   * Date the Quote was initially Created
   * @return createdDate
  **/
  @Schema(example = "Tue Oct 08 00:00:00 GMT 2019", description = "Date the Quote was initially Created")
  public LocalDate getCreatedDate() {
    return createdDate;
  }

  public void setCreatedDate(LocalDate createdDate) {
    this.createdDate = createdDate;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList lastModifiedDate(LocalDate lastModifiedDate) {
    this.lastModifiedDate = lastModifiedDate;
    return this;
  }

   /**
   * Date the Quote was last updated or modified.
   * @return lastModifiedDate
  **/
  @Schema(example = "Tue Oct 08 00:00:00 GMT 2019", description = "Date the Quote was last updated or modified.")
  public LocalDate getLastModifiedDate() {
    return lastModifiedDate;
  }

  public void setLastModifiedDate(LocalDate lastModifiedDate) {
    this.lastModifiedDate = lastModifiedDate;
  }

  public QuoteListResponseQuoteSearchResponseQuoteList quoteExpiryDate(LocalDate quoteExpiryDate) {
    this.quoteExpiryDate = quoteExpiryDate;
    return this;
  }

   /**
   * Date the Quote Expires
   * @return quoteExpiryDate
  **/
  @Schema(example = "Tue Oct 08 00:00:00 GMT 2019", description = "Date the Quote Expires")
  public LocalDate getQuoteExpiryDate() {
    return quoteExpiryDate;
  }

  public void setQuoteExpiryDate(LocalDate quoteExpiryDate) {
    this.quoteExpiryDate = quoteExpiryDate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QuoteListResponseQuoteSearchResponseQuoteList quoteListResponseQuoteSearchResponseQuoteList = (QuoteListResponseQuoteSearchResponseQuoteList) o;
    return Objects.equals(this.quoteGuid, quoteListResponseQuoteSearchResponseQuoteList.quoteGuid) &&
        Objects.equals(this.quoteName, quoteListResponseQuoteSearchResponseQuoteList.quoteName) &&
        Objects.equals(this.quoteNumber, quoteListResponseQuoteSearchResponseQuoteList.quoteNumber) &&
        Objects.equals(this.revisionNumber, quoteListResponseQuoteSearchResponseQuoteList.revisionNumber) &&
        Objects.equals(this.endUserName, quoteListResponseQuoteSearchResponseQuoteList.endUserName) &&
        Objects.equals(this.bidNumber, quoteListResponseQuoteSearchResponseQuoteList.bidNumber) &&
        Objects.equals(this.totalAmount, quoteListResponseQuoteSearchResponseQuoteList.totalAmount) &&
        Objects.equals(this.quoteStatus, quoteListResponseQuoteSearchResponseQuoteList.quoteStatus) &&
        Objects.equals(this.createdDate, quoteListResponseQuoteSearchResponseQuoteList.createdDate) &&
        Objects.equals(this.lastModifiedDate, quoteListResponseQuoteSearchResponseQuoteList.lastModifiedDate) &&
        Objects.equals(this.quoteExpiryDate, quoteListResponseQuoteSearchResponseQuoteList.quoteExpiryDate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(quoteGuid, quoteName, quoteNumber, revisionNumber, endUserName, bidNumber, totalAmount, quoteStatus, createdDate, lastModifiedDate, quoteExpiryDate);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QuoteListResponseQuoteSearchResponseQuoteList {\n");
    
    sb.append("    quoteGuid: ").append(toIndentedString(quoteGuid)).append("\n");
    sb.append("    quoteName: ").append(toIndentedString(quoteName)).append("\n");
    sb.append("    quoteNumber: ").append(toIndentedString(quoteNumber)).append("\n");
    sb.append("    revisionNumber: ").append(toIndentedString(revisionNumber)).append("\n");
    sb.append("    endUserName: ").append(toIndentedString(endUserName)).append("\n");
    sb.append("    bidNumber: ").append(toIndentedString(bidNumber)).append("\n");
    sb.append("    totalAmount: ").append(toIndentedString(totalAmount)).append("\n");
    sb.append("    quoteStatus: ").append(toIndentedString(quoteStatus)).append("\n");
    sb.append("    createdDate: ").append(toIndentedString(createdDate)).append("\n");
    sb.append("    lastModifiedDate: ").append(toIndentedString(lastModifiedDate)).append("\n");
    sb.append("    quoteExpiryDate: ").append(toIndentedString(quoteExpiryDate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
